#ifndef SBK_KSystemClipboardWrapper_H
#define SBK_KSystemClipboardWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <ksystemclipboard.h>

namespace PySide { class DynamicQMetaObject; }

class KSystemClipboardWrapper : public KSystemClipboard
{
public:
    KSystemClipboardWrapper(const KSystemClipboardWrapper &) = delete;
    KSystemClipboardWrapper& operator=(const KSystemClipboardWrapper &) = delete;
    KSystemClipboardWrapper(KSystemClipboardWrapper &&) = delete;
    KSystemClipboardWrapper& operator=(KSystemClipboardWrapper &&) = delete;

    KSystemClipboardWrapper(::QObject * parent);
    void childEvent(::QChildEvent * event) override;
    void clear(::QClipboard::Mode mode) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    const ::QMimeData * mimeData(::QClipboard::Mode mode) const override;
    void setMimeData(::QMimeData * mime, ::QClipboard::Mode mode) override;
    void timerEvent(::QTimerEvent * event) override;
    ~KSystemClipboardWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_KSystemClipboardWrapper_H

